/* 
  5/27/2020 - Start Baseball Bags game with Adafruit 3mm 
              IR Breakbeam sensor
  5/29/2020 - Seems to work, add delay() or IR worked too fast
  5/31/2020 - Add large single 7-segment LED for inning indicator
  6/1/2020  - Start listing vaiables for at bat and HOME and AWAY teams
              Use the remainder function (%)
  6/1/2020 -- Added "At Bat" button to advance each half inning
  6/2/2020 -- Used homeaway variable to show score on different 
              Adafruit 4-digit 7-segment LEDs
  6/2/2020 -- Add reset button to start new game (zero everything
              out)
  6/3/2020 -- Tested - seemed to work, didn't have 2nd 7-segment
              for HOME team yet
  6/4/2020 -- Added the other scoring sensors code (20,25,50,75,100)
  6/14/2020-- Got sensors wired in play box. Need to tweek a few lines
           -- Fixed Matrix2 not resetting, had wrong address
  6/15/2020-- Added brightness and dot for which team up
           -- Added LED for watch team up - took out 7/1/2020
  6/16/2020-- LEDs don't work on A4 & A5, brightness works but not dot
           -- Hook LEDs up permanently
  7/2/2020 -- Clean up code for Instructables
           -- Left LCD monitor code in, though don't use in final game
*/

#include <Wire.h> 
#include <Adafruit_GFX.h> 
#include "Adafruit_LEDBackpack.h" 
 
Adafruit_7segment matrix1 = Adafruit_7segment(); 
Adafruit_7segment matrix2 = Adafruit_7segment(); 

#include<Wire.h>
#include<LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

#define LEDPIN 13              // ------ LED that a bag scored

#define SENSORPIN10 9
#define SENSORPIN20 10
#define SENSORPIN25 11
#define SENSORPIN50 12
#define SENSORPIN75 A2
#define SENSORPIN100 A3

#define BUTTONPINreset A0    //---Reset, cancel, new game
#define BUTTONPINatbat A1    //---Switch between Home/Away

int sensorState10 = 0; 
int sensorState20 = 0; 
int sensorState25 = 0; 
int sensorState50 = 0; 
int sensorState75 = 0; 
int sensorState100 = 0; 

int sensorStatereset = 0; 
int sensorStateatbat = 0; 
     
int totalscore1;
int totalscore2;

int atbat;
int inn;
int homeaway;

//=========================Large 7-segment LED Display===================
byte seven_seg_digits[10][7] = { { 1,1,1,1,1,1,0 },  // = 0
                                                    { 0,1,1,0,0,0,0 },  // = 1
                                                    { 1,1,0,1,1,0,1 },  // = 2
                                                    { 1,1,1,1,0,0,1 },  // = 3
                                                    { 0,1,1,0,0,1,1 },  // = 4
                                                    { 1,0,1,1,0,1,1 },  // = 5
                                                    { 1,0,1,1,1,1,1 },  // = 6
                                                    { 1,1,1,0,0,0,0 },  // = 7
                                                    { 1,1,1,1,1,1,1 },  // = 8
                                                    { 1,1,1,0,0,1,1 }   // = 9
                                                    };

 void sevenSegWrite(byte digit) {
  byte pin = 2;
  for (byte segCount = 0; segCount < 7; ++segCount) {
    digitalWrite(pin, seven_seg_digits[digit][segCount]);
    ++pin;
  }
}
//================Display Inning you are playing============================

void setup() {
  
//=====================Set pins for Single 7-segment inning display
  pinMode(2, OUTPUT);   
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
//==========================================================================
  
  pinMode(LEDPIN, OUTPUT);               //----LED for bag scored
  
  pinMode(SENSORPIN10, INPUT_PULLUP); 
  pinMode(SENSORPIN20, INPUT_PULLUP); 
  pinMode(SENSORPIN25, INPUT_PULLUP); 
  pinMode(SENSORPIN50, INPUT_PULLUP); 
  pinMode(SENSORPIN75, INPUT_PULLUP); 
  pinMode(SENSORPIN100, INPUT_PULLUP); 

  pinMode(BUTTONPINreset, INPUT_PULLUP); 
  pinMode(BUTTONPINatbat, INPUT_PULLUP); 
  
  digitalWrite(SENSORPIN10, HIGH);         // turn on the pullups
  digitalWrite(SENSORPIN20, HIGH); 
  digitalWrite(SENSORPIN25, HIGH); 
  digitalWrite(SENSORPIN50, HIGH); 
  digitalWrite(SENSORPIN75, HIGH); 
  digitalWrite(SENSORPIN100, HIGH); 
     
  matrix1.begin(0x70);
  matrix1.println(0,DEC); 
  matrix1.writeDisplay();  
  matrix2.begin(0x72);
  matrix2.println(0,DEC); 
  matrix2.writeDisplay();  
  delay(10);
  
  totalscore1 = 0;      //-- AWAY Team
  totalscore2 = 0;      //-- HOME Team
  atbat = 2;            //-- what team is at bat divide by 2
  inn = 1;              //-- inning 7-segment display
  homeaway = 0;         //-- Start with AWAY team up

  Serial.begin(9600);
  Serial.println ("Bags Baseball");
  Serial.print("AWAY Team Starts"); 
   
  lcd.begin(20,4); 
  lcd.setCursor(3,0); 
  lcd.print("Bags Baseball"); 
  lcd.setCursor(1,2); 
  lcd.print("AWAY Team Starts"); 

  sevenSegWrite(1);        // --------------Start at first inning
}

void loop()
{
   sensorState10 = digitalRead(SENSORPIN10);   //-- read the state  value
   sensorState20 = digitalRead(SENSORPIN20);  
   sensorState25 = digitalRead(SENSORPIN25); 
   sensorState50 = digitalRead(SENSORPIN50);  
   sensorState75 = digitalRead(SENSORPIN75); 
   sensorState100 = digitalRead(SENSORPIN100); 
 
   sensorStatereset = digitalRead(BUTTONPINreset); 
   sensorStateatbat = digitalRead(BUTTONPINatbat); 

 if (sensorStatereset == LOW)       //-- check if the sensor beam is broken
   {             
    delay(300);
    totalscore1 = 0;       //-- AWAY Team
    totalscore2 = 0;       //-- HOME Team
    atbat = 2;             // - inning and what team at bat
    inn = 1;               //-- inning 7-segment display
    homeaway = 0;          //-- Start with AWAY team up

    lcd.begin(20,4); 
    lcd.setCursor(3,0); 
    lcd.print("Bags Baseball"); 
    lcd.setCursor(1,2); 
    lcd.print("AWAY Team Starts"); 

    sevenSegWrite(1);   
    matrix1.begin(0x70);
    matrix1.println(0,DEC); 
    matrix1.writeDisplay();  
    matrix2.begin(0x72);
    matrix2.println(0,DEC); 
    matrix2.writeDisplay();  
    delay(10);
   }

 if (sensorStateatbat == LOW)       //-- check if the sensor beam is broken
   {             
    delay(300);
    atbat = atbat + 1;             //--Increment as each turn at bat
    homeaway = atbat % 2;          //---Remainder, 0=AWAY, 1=HOME
    
    inn = (atbat/2);               //---Display inning you are in
    sevenSegWrite(inn);            //---Display on middle large 7-segment

    lcd.clear();
    lcd.setCursor(4,0); 
    lcd.print("Inning: "); 
    lcd.print(inn);

    lcd.setCursor(4,1); 
    lcd.print("At Bat: ");
    lcd.print(atbat); 

    lcd.setCursor(4,2); 
    lcd.print("Home Away: ");
    lcd.print(homeaway); 
    
     if (homeaway > 0)
      {
        lcd.setCursor(2,3); 
        lcd.print("HOME Team Up"); 
        Serial.print("HOME Team Up"); 
        matrix1.setBrightness(0);           //--added 6/15/2020
        matrix2.setBrightness(15);          //--added 6/15/2020
        delay(10);
      }
      else
      {
        lcd.setCursor(2,3); 
        lcd.print("AWAY Team Up"); 
        Serial.println("AWAY Team Up"); 
        matrix1.setBrightness(15);          //--added 6/15/2020
        matrix2.setBrightness(0);           //--added 6/15/2020
        delay(10);
      }
   } 
    
  if (sensorState10 == LOW) {        // check if WALK sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);     // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 10;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1); 
      }
     else
      {
       totalscore2 = totalscore2 + 10;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }

  if (sensorState20 == LOW) {       // check if STOLEN BASE sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);     // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 20;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1); 
      }
     else
      {
       totalscore2 = totalscore2 + 20;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }  


  if (sensorState25 == LOW) {       // check if SINGLE sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);     // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 25;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1); 
      }
     else
      {
       totalscore2 = totalscore2 + 25;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }  


  if (sensorState50 == LOW) {        // check if DOUBLE sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);      // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 50;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1);

        Serial.println (totalscore1);
      }
     else
      {
       totalscore2 = totalscore2 + 50;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 

        Serial.println (totalscore2);
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }  


  if (sensorState75 == LOW) {        // check if TRIPLE sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);      // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 75;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1);
      }
     else
      {
       totalscore2 = totalscore2 + 75;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }  

  if (sensorState100 == LOW) {        // check if HR sensor beam is broken
    delay(100);
    digitalWrite(LEDPIN, HIGH);      // turn LED on:
    delay(150);
     if (homeaway == 0)
      {
       totalscore1 = totalscore1 + 100;  //----AWAY Team
       matrix1.print(totalscore1);
       matrix1.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("AWAY Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore1); 
       Serial.println(totalscore1);
      }
     else
      {
       totalscore2 = totalscore2 + 100;   //----HOME Team
       matrix2.print(totalscore2);
       matrix2.writeDisplay(); 

       lcd.clear();
       lcd.setCursor(4,0); 
       lcd.print("HOME Team"); 
       lcd.setCursor(4,1); 
       lcd.print("Total Score:"); 
       lcd.setCursor(7,2); 
       lcd.print(totalscore2); 
      }
   
    } 
    else 
    {
      digitalWrite(LEDPIN, LOW);    // turn LED off:
    }  

}   //========================================================= End of Loop Function
   
